Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1821)
+++ palm/trunk/SOURCE/Makefile	(revision 1822)
@@ -20,5 +20,6 @@
 # Current revisions:
 # ------------------
-# 
+# Tails removed. lpm_release_set removed. calc_precipitation, impact_of_latent_heat
+# removed. 
 # 
 # Former revisions:
@@ -246,5 +247,5 @@
 	advec_w_pw.f90 advec_w_up.f90 average_3d_data.f90 boundary_conds.f90 \
 	buoyancy.f90 calc_liquid_water_content.f90 calc_mean_profile.f90 \
-	calc_precipitation.f90 calc_radiation.f90 \
+	calc_radiation.f90 \
 	check_for_restart.f90 check_open.f90 check_parameters.f90 \
 	close_file.f90 compute_vpt.f90 coriolis.f90 cpulog.f90 \
@@ -257,5 +258,5 @@
 	disturb_heatflux.f90 eqn_state_seawater.f90 exchange_horiz.f90 \
 	exchange_horiz_2d.f90 fft_xy.f90 flow_statistics.f90 \
-	global_min_max.f90 header.f90 impact_of_latent_heat.f90 \
+	global_min_max.f90 header.f90 \
 	inflow_turbulence.f90 init_1d_model.f90 init_3d_model.f90 \
 	init_advec.f90 init_cloud_physics.f90 init_coupling.f90 init_dvrp.f90 \
@@ -268,7 +269,6 @@
 	lpm_data_output_particles.f90 lpm_droplet_collision.f90 \
 	lpm_droplet_condensation.f90 lpm_exchange_horiz.f90 \
-	lpm_extend_tails.f90 \
-	lpm_extend_tail_array.f90 lpm_init.f90 lpm_init_sgs_tke.f90 \
-	lpm_pack_arrays.f90 lpm_read_restart_file.f90 lpm_release_set.f90 \
+	lpm_init.f90 lpm_init_sgs_tke.f90 \
+	lpm_pack_arrays.f90 lpm_read_restart_file.f90 \
 	lpm_set_attributes.f90 \
 	lpm_write_exchange_statistics.f90 lpm_write_restart_file.f90 \
@@ -349,5 +349,4 @@
 calc_mean_profile.o: modules.o mod_kinds.o
 calc_liquid_water_content.o: modules.o mod_kinds.o
-calc_precipitation.o: modules.o mod_kinds.o
 calc_radiation.o: modules.o mod_kinds.o
 check_for_restart.o: modules.o mod_kinds.o pmc_interface.o
@@ -395,5 +394,4 @@
    plant_canopy_model.o pmc_handle_communicator.o pmc_interface.o \
    radiation_model.o spectrum.o subsidence.o 
-impact_of_latent_heat.o: modules.o mod_kinds.o
 inflow_turbulence.o: modules.o cpulog.o mod_kinds.o
 init_1d_model.o: modules.o mod_kinds.o
@@ -418,6 +416,6 @@
 local_tremain.o: modules.o cpulog.o mod_kinds.o
 local_tremain_ini.o: modules.o cpulog.o mod_kinds.o
-lpm.o: modules.o cpulog.o lpm_exchange_horiz.o lpm_pack_arrays.o mod_kinds.o \
-	mod_particle_attributes.o
+lpm.o: modules.o cpulog.o lpm_exchange_horiz.o lpm_init.o lpm_pack_arrays.o \
+	mod_kinds.o mod_particle_attributes.o
 lpm_advec.o: modules.o cpulog.o mod_kinds.o mod_particle_attributes.o
 lpm_boundary_conds.o: modules.o cpulog.o mod_kinds.o mod_particle_attributes.o
@@ -434,6 +432,4 @@
 lpm_exchange_horiz.o: modules.o cpulog.o lpm_pack_arrays.o mod_kinds.o \
 	mod_particle_attributes.o netcdf_interface.o
-lpm_extend_tails.o: modules.o mod_kinds.o mod_particle_attributes.o
-lpm_extend_tail_array.o: modules.o mod_kinds.o mod_particle_attributes.o
 lpm_init.o: modules.o lpm_collision_kernels.o mod_kinds.o \
 	netcdf_interface.o random_function.o mod_particle_attributes.o \
@@ -443,6 +439,4 @@
 lpm_read_restart_file.o: modules.o mod_kinds.o mod_particle_attributes.o \
 	lpm_pack_arrays.o
-lpm_release_set.o: modules.o mod_kinds.o random_function.o \
-	mod_particle_attributes.o lpm_init.o  random_generator_parallel.o
 lpm_set_attributes.o: modules.o cpulog.o mod_kinds.o mod_particle_attributes.o
 lpm_write_exchange_statistics.o: modules.o mod_kinds.o mod_particle_attributes.o
@@ -480,7 +474,7 @@
 prognostic_equations.o: modules.o advec_s_pw.o advec_s_up.o advec_s_bc.o advec_u_pw.o \
 	advec_u_up.o advec_v_pw.o advec_v_up.o advec_w_pw.o advec_w_up.o \
-	advec_ws.o buoyancy.o calc_precipitation.o calc_radiation.o coriolis.o \
+	advec_ws.o buoyancy.o calc_radiation.o coriolis.o \
 	cpulog.o diffusion_e.o diffusion_s.o diffusion_u.o diffusion_v.o diffusion_w.o \
-	eqn_state_seawater.o impact_of_latent_heat.o mod_kinds.o microphysics.o \
+	eqn_state_seawater.o mod_kinds.o microphysics.o \
 	nudging.o plant_canopy_model.o production_e.o radiation_model.o \
 	subsidence.o user_actions.o
Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 1821)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! icloud_scheme removed, microphysics_seifert added
 ! 
 ! Former revisions:
@@ -222,7 +222,7 @@
 
        USE control_parameters,                                                 &
-           ONLY:  cloud_physics, humidity, icloud_scheme, loop_optimization,   &
-                  monotonic_adjustment, passive_scalar, precipitation, ocean,  &
-                  ws_scheme_mom, ws_scheme_sca
+           ONLY:  cloud_physics, humidity, loop_optimization,                  &
+                  monotonic_adjustment, passive_scalar, microphysics_seifert,  &
+                  ocean, ws_scheme_mom, ws_scheme_sca
 
        USE indices,                                                            &
@@ -274,6 +274,5 @@
           ENDIF
 
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
-               precipitation )  THEN
+          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              ALLOCATE( sums_wsqrs_ws_l(nzb:nzt+1,0:threads_per_task-1) )
              ALLOCATE( sums_wsnrs_ws_l(nzb:nzt+1,0:threads_per_task-1) )
@@ -331,6 +330,5 @@
              ENDIF
 
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
-                  precipitation )  THEN
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 ALLOCATE( flux_s_qr(nzb+1:nzt,0:threads_per_task-1),           &
                           diss_s_qr(nzb+1:nzt,0:threads_per_task-1),           &
@@ -365,6 +363,6 @@
     
        USE control_parameters,                                                 &
-           ONLY:  cloud_physics, humidity, icloud_scheme, passive_scalar,      &
-                  precipitation, ocean, ws_scheme_mom, ws_scheme_sca
+           ONLY:  cloud_physics, humidity, passive_scalar, ocean,              &
+                  microphysics_seifert, ws_scheme_mom, ws_scheme_sca
 
        USE kinds
@@ -391,6 +389,5 @@
           sums_wspts_ws_l = 0.0_wp
           IF ( humidity  .OR.  passive_scalar )  sums_wsqs_ws_l = 0.0_wp
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
-               precipitation )  THEN
+          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              sums_wsqrs_ws_l = 0.0_wp
              sums_wsnrs_ws_l = 0.0_wp
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 1821)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! icloud_scheme removed. microphyisics_seifert added.
 !
 ! Former revisions:
@@ -139,9 +139,9 @@
                cloud_physics, dt_3d, humidity,                                 &
                ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_sa_t, ibc_uv_b,       &
-               ibc_uv_t, icloud_scheme, inflow_l, inflow_n, inflow_r, inflow_s,&
-               intermediate_timestep_count, large_scale_forcing, nest_domain,  &
-               nest_bound_l, nest_bound_s, nudging, ocean,                     &
-               outflow_l, outflow_n, outflow_r, outflow_s, passive_scalar,     &
-               precipitation, tsc, use_cmax
+               ibc_uv_t, inflow_l, inflow_n, inflow_r, inflow_s,               &
+               intermediate_timestep_count, large_scale_forcing,               &
+               microphysics_seifert, nest_domain, nest_bound_l, nest_bound_s,  &
+               nudging, ocean, outflow_l, outflow_n, outflow_r, outflow_s,     &
+               passive_scalar, tsc, use_cmax
 
     USE grid_variables,                                                        &
@@ -319,5 +319,5 @@
        ENDIF
 
-       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  precipitation )  THEN
+       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 !             
 !--       Surface conditions rain water (Dirichlet)
@@ -373,6 +373,5 @@
        IF ( humidity  .OR.  passive_scalar )  THEN
           q_p(:,nys-1,:) = q_p(:,nys,:)
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
-               precipitation)  THEN
+          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              qr_p(:,nys-1,:) = qr_p(:,nys,:)
              nr_p(:,nys-1,:) = nr_p(:,nys,:)
@@ -384,6 +383,5 @@
        IF ( humidity  .OR.  passive_scalar )  THEN
           q_p(:,nyn+1,:) = q_p(:,nyn,:)
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
-               precipitation )  THEN
+          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              qr_p(:,nyn+1,:) = qr_p(:,nyn,:)
              nr_p(:,nyn+1,:) = nr_p(:,nyn,:)
@@ -395,6 +393,5 @@
        IF ( humidity  .OR.  passive_scalar )  THEN
           q_p(:,:,nxl-1) = q_p(:,:,nxl)
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
-               precipitation )  THEN
+          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              qr_p(:,:,nxl-1) = qr_p(:,:,nxl)
              nr_p(:,:,nxl-1) = nr_p(:,:,nxl)
@@ -406,5 +403,5 @@
        IF ( humidity .OR. passive_scalar )  THEN
           q_p(:,:,nxr+1) = q_p(:,:,nxr)
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  precipitation )  THEN
+          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              qr_p(:,:,nxr+1) = qr_p(:,:,nxr)
              nr_p(:,:,nxr+1) = nr_p(:,:,nxr)
Index: palm/trunk/SOURCE/calc_liquid_water_content.f90
===================================================================
--- palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 1821)
+++ palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! icloud_scheme removed. microphysics_seifert added.
 ! 
 ! Former revisions:
@@ -73,5 +73,5 @@
 
     USE control_parameters,                                                    &
-        ONLY:  icloud_scheme, precipitation
+        ONLY:  microphysics_seifert
 
     USE indices,                                                               &
@@ -122,5 +122,5 @@
 !
 !--          Compute the liquid water content
-             IF ( icloud_scheme == 0  .AND.  precipitation)  THEN
+             IF ( microphysics_seifert )  THEN
                 IF ( ( q(k,j,i) - q_s - qr(k,j,i) ) > 0.0_wp ) THEN
                    qc(k,j,i) = q(k,j,i) - q_s - qr(k,j,i)
@@ -131,17 +131,11 @@
                    ql(k,j,i) = qr(k,j,i)
                 ENDIF
-             ELSEIF ( icloud_scheme == 0  .AND.  .NOT. precipitation )  THEN
+             ELSE
                 IF ( ( q(k,j,i) - q_s ) > 0.0_wp ) THEN
                    qc(k,j,i) = q(k,j,i) - q_s
                    ql(k,j,i) = qc(k,j,i)
                 ELSE
-                   qc(k,j,i) = 0.0_wp 
+                   qc(k,j,i) = 0.0_wp
                    ql(k,j,i) = 0.0_wp
-                ENDIF
-             ELSE
-                IF ( ( q(k,j,i) - q_s ) > 0.0_wp ) THEN
-                   ql(k,j,i) = q(k,j,i) - q_s
-                ELSE
-                   ql(k,j,i) = 0.0_wp 
                 ENDIF
              ENDIF
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1821)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1822)
@@ -19,5 +19,13 @@
 ! Current revisions:
 ! -----------------
-! 
+! PALM collision kernel deleted. Collision algorithms are checked for correct
+! spelling.
+!
+! Tails removed.
+!
+! Checks for use_sgs_for_particles adopted for the use of droplets with
+! use_sgs_for_particles adopted.
+!
+! Unused variables removed.
 ! 
 ! Former revisions:
@@ -358,5 +366,5 @@
     CHARACTER (LEN=1)   ::  sq                       !< 
     CHARACTER (LEN=15)  ::  var                      !< 
-    CHARACTER (LEN=7)   ::  unit                     !< 
+    CHARACTER (LEN=7)   ::  unit                     !<
     CHARACTER (LEN=8)   ::  date                     !< 
     CHARACTER (LEN=10)  ::  time                     !< 
@@ -367,6 +375,5 @@
 
     INTEGER(iwp) ::  i                               !< 
-    INTEGER(iwp) ::  ilen                            !< 
-    INTEGER(iwp) ::  iremote = 0                     !< 
+    INTEGER(iwp) ::  ilen                            !<
     INTEGER(iwp) ::  j                               !< 
     INTEGER(iwp) ::  k                               !< 
@@ -374,5 +381,4 @@
     INTEGER(iwp) ::  netcdf_data_format_save         !< 
     INTEGER(iwp) ::  position                        !<
-    INTEGER(iwp) ::  prec                            !< 
     
     LOGICAL     ::  found                            !< 
@@ -661,12 +667,4 @@
                         'with particle advection.'
        CALL message( 'check_parameters', 'PA0017', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!--
-    IF ( use_particle_tails )  THEN
-       message_string = 'Particle tails are currently not available due ' //   &
-                        'to the new particle structure.'
-       CALL message( 'check_parameters', 'PA0392', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -767,8 +765,19 @@
 !
 !-- Check cloud scheme
-    IF ( cloud_scheme == 'seifert_beheng' )  THEN
-       icloud_scheme = 0
+    IF ( cloud_scheme == 'saturation_adjust' )  THEN
+       microphysics_sat_adjust = .TRUE.
+       microphysics_seifert    = .FALSE.
+       microphysics_kessler    = .FALSE.
+       precipitation           = .FALSE.
+    ELSEIF ( cloud_scheme == 'seifert_beheng' )  THEN
+       microphysics_sat_adjust = .FALSE.
+       microphysics_seifert    = .TRUE.
+       microphysics_kessler    = .FALSE.
+       precipitation           = .TRUE.
     ELSEIF ( cloud_scheme == 'kessler' )  THEN
-       icloud_scheme = 1
+       microphysics_sat_adjust = .FALSE.
+       microphysics_seifert    = .FALSE.
+       microphysics_kessler    = .TRUE.
+       precipitation           = .TRUE.
     ELSE
        message_string = 'unknown cloud microphysics scheme cloud_scheme ="' // &
@@ -846,7 +855,7 @@
     ENDIF
 
-    IF ( use_sgs_for_particles  .AND.  .NOT. use_upstream_for_tke .AND.        &
-         ( scalar_advec /= 'ws-scheme' .OR.                                    &
-           scalar_advec /= 'ws-scheme-mono' )                                  &
+    IF ( use_sgs_for_particles  .AND.  .NOT. cloud_droplets  .AND.               &
+         .NOT. use_upstream_for_tke  .AND.                                       &
+         ( scalar_advec /= 'ws-scheme'  .OR.  scalar_advec /= 'ws-scheme-mono' ) &
        )  THEN
        use_upstream_for_tke = .TRUE.
@@ -906,7 +915,4 @@
           hall_kernel = .TRUE.
 
-       CASE ( 'palm' )
-          palm_kernel = .TRUE.
-
        CASE ( 'wang', 'wang_fast' )
           wang_kernel = .TRUE.
@@ -922,4 +928,21 @@
     END SELECT
     IF ( collision_kernel(6:9) == 'fast' )  use_kernel_tables = .TRUE.
+
+!
+!-- Collision algorithms:
+    SELECT CASE ( TRIM( collision_algorithm ) )
+
+       CASE ( 'all_or_nothing' )
+          all_or_nothing = .TRUE.
+
+       CASE ( 'average_impact' )
+          average_impact = .TRUE.
+
+       CASE DEFAULT
+          message_string = 'unknown collision algorithm: collision_algorithm = "' // &
+                           TRIM( collision_algorithm ) // '"'
+          CALL message( 'check_parameters', 'PA0420', 1, 2, 0, 6, 0 )
+
+       END SELECT
 
     IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
@@ -979,10 +1002,4 @@
               'not allowed with humidity = ', humidity
        CALL message( 'check_parameters', 'PA0034', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( precipitation  .AND.  .NOT.  cloud_physics )  THEN
-       WRITE( message_string, * ) 'precipitation = ', precipitation, ' is ',   &
-              'not allowed with cloud_physics = ', cloud_physics
-       CALL message( 'check_parameters', 'PA0035', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -1032,5 +1049,5 @@
        ENDIF 
 
-       IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
           message_string = 'plant_canopy = .TRUE. requires cloud_scheme /=' // &
                            ' seifert_beheng'
@@ -1095,5 +1112,5 @@
     IF ( .NOT. ( loop_optimization == 'cache'  .OR.                            &
                  loop_optimization == 'vector' )                               &
-         .AND.  cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+         .AND.  cloud_physics  .AND.  microphysics_seifert )  THEN
        message_string = 'cloud_scheme = seifert_beheng requires ' //           &
                         'loop_optimization = "cache" or "vector"'
@@ -2152,5 +2169,5 @@
 !
 !-- Set the default value for the integration interval of precipitation amount
-    IF ( precipitation )  THEN
+    IF ( microphysics_seifert  .OR.  microphysics_kessler )  THEN
        IF ( precipitation_amount_interval == 9999999.9_wp )  THEN
           precipitation_amount_interval = dt_do2d_xy
@@ -2782,14 +2799,9 @@
                                  'lemented for cloud_physics = .FALSE.'
                 CALL message( 'check_parameters', 'PA0094', 1, 2, 0, 6, 0 )
-             ELSEIF ( icloud_scheme /= 0 )  THEN
+             ELSEIF ( .NOT.  microphysics_seifert )  THEN
                 message_string = 'data_output_pr = ' //                        &
                                  TRIM( data_output_pr(i) ) // ' is not imp' // &
                                  'lemented for cloud_scheme /= seifert_beheng'
                 CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
-             ELSEIF (  .NOT.  precipitation )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for precipitation = .FALSE.'
-                CALL message( 'check_parameters', 'PA0361', 1, 2, 0, 6, 0 )
              ELSE
                 dopr_index(i) = 73
@@ -2804,14 +2816,9 @@
                                  'lemented for cloud_physics = .FALSE.'
                 CALL message( 'check_parameters', 'PA0094', 1, 2, 0, 6, 0 )
-             ELSEIF ( icloud_scheme /= 0 )  THEN
+             ELSEIF ( .NOT.  microphysics_seifert )  THEN
                 message_string = 'data_output_pr = ' //                        &
                                  TRIM( data_output_pr(i) ) // ' is not imp' // &
                                  'lemented for cloud_scheme /= seifert_beheng'
                 CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
-             ELSEIF (  .NOT.  precipitation )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for precipitation = .FALSE.'
-                CALL message( 'check_parameters', 'PA0361', 1, 2, 0, 6, 0 )
              ELSE
                 dopr_index(i) = 74
@@ -2826,9 +2833,4 @@
                                  'lemented for cloud_physics = .FALSE.'
                 CALL message( 'check_parameters', 'PA0094', 1, 2, 0, 6, 0 )
-             ELSEIF ( icloud_scheme /= 0 )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for cloud_scheme /= seifert_beheng'
-                CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
              ELSE
                 dopr_index(i) = 75
@@ -2843,15 +2845,9 @@
                                  'lemented for cloud_physics = .FALSE.'
                 CALL message( 'check_parameters', 'PA0094', 1, 2, 0, 6, 0 )
-             ELSEIF ( icloud_scheme /= 0 )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for cloud_scheme /= seifert_beheng'
-                CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
-             ELSEIF (  .NOT.  precipitation )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for precipitation = .FALSE.'
-                CALL message( 'check_parameters', 'PA0361', 1, 2, 0, 6, 0 )
-
+             ELSEIF ( microphysics_sat_adjust )  THEN
+                message_string = 'data_output_pr = ' //                        &
+                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
+                                 'ilable for cloud_scheme = saturation_adjust'
+                CALL message( 'check_parameters', 'PA0422', 1, 2, 0, 6, 0 )
              ELSE
                 dopr_index(i) = 76
@@ -3203,5 +3199,5 @@
                          'res cloud_physics = .TRUE.'
                 CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
-             ELSEIF ( icloud_scheme /= 0 )  THEN
+             ELSEIF ( .NOT.  microphysics_seifert )  THEN
                 message_string = 'output of "' // TRIM( var ) // '" requi' //  &
                          'res cloud_scheme = seifert_beheng'
@@ -3224,12 +3220,8 @@
                          'res cloud_physics = .TRUE.'
                 CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
-             ELSEIF ( icloud_scheme /= 0 )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                         'res cloud_scheme = seifert_beheng'
-                CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
-             ELSEIF (  .NOT.  precipitation )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res precipitation = .TRUE.'
-                CALL message( 'check_parameters', 'PA0112', 1, 2, 0, 6, 0 )
+             ELSEIF ( microphysics_sat_adjust )  THEN
+                message_string = 'output of "' // TRIM( var ) // '" is ' //  &
+                         'not available for cloud_scheme = saturation_adjust'
+                CALL message( 'check_parameters', 'PA0423', 1, 2, 0, 6, 0 )
              ENDIF
              unit = 'kg/kg m/s'
@@ -3249,8 +3241,4 @@
                          'res cloud_physics = .TRUE.'
                 CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
-             ELSEIF ( icloud_scheme /= 0 ) THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                         'res cloud_scheme = seifert_beheng'
-                CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
              ENDIF
              unit = 'kg/kg'
@@ -3279,12 +3267,8 @@
                          'res cloud_physics = .TRUE.'
                 CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
-             ELSEIF ( icloud_scheme /= 0 ) THEN
+             ELSEIF ( .NOT.  microphysics_seifert ) THEN
                 message_string = 'output of "' // TRIM( var ) // '" requi' //  &
                          'res cloud_scheme = seifert_beheng'
                 CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
-             ELSEIF (  .NOT.  precipitation )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res precipitation = .TRUE.'
-                CALL message( 'check_parameters', 'PA0112', 1, 2, 0, 6, 0 )
              ENDIF
              unit = 'kg/kg'
@@ -3371,7 +3355,8 @@
                 CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
              ENDIF
-             IF ( TRIM( var ) == 'pra*'  .AND.  .NOT. precipitation )  THEN
+             IF ( TRIM( var ) == 'pra*'  .AND.                                 &
+                  .NOT. ( microphysics_kessler .OR. microphysics_seifert ) )  THEN
                 message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res precipitation = .TRUE.'
+                                 'res cloud_scheme = kessler or seifert_beheng'
                 CALL message( 'check_parameters', 'PA0112', 1, 2, 0, 6, 0 )
              ENDIF
@@ -3381,7 +3366,8 @@
                 CALL message( 'check_parameters', 'PA0113', 1, 2, 0, 6, 0 )
              ENDIF
-             IF ( TRIM( var ) == 'prr*'  .AND.  .NOT.  precipitation )  THEN
+             IF ( TRIM( var ) == 'prr*'  .AND.                                 &
+                  .NOT. ( microphysics_kessler .OR. microphysics_seifert ) )  THEN
                 message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res precipitation = .TRUE.'
+                                 'res cloud_scheme = kessler or seifert_beheng'
                 CALL message( 'check_parameters', 'PA0112', 1, 2, 0, 6, 0 )
              ENDIF
Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 1821)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Output of bulk cloud physics simplified.
 ! 
 ! Former revisions:
@@ -146,8 +146,8 @@
                do2d_xz_last_time, do2d_xz_n, do2d_xz_time_count,               &
                do2d_yz_last_time, do2d_yz_n, do2d_yz_time_count,               &
-               ibc_uv_b, icloud_scheme, io_blocks, io_group,                   &
-               message_string,                             &
-               ntdim_2d_xy, ntdim_2d_xz, ntdim_2d_yz, psolver, section,        &
-               simulated_time,  simulated_time_chr, time_since_reference_point
+               ibc_uv_b, io_blocks, io_group, message_string,                  &
+               ntdim_2d_xy, ntdim_2d_xz, ntdim_2d_yz,                          &
+               psolver, section, simulated_time, simulated_time_chr,           &
+               time_since_reference_point
         
     USE cpulog,                                                                &
@@ -683,58 +683,39 @@
 
              CASE ( 'prr*_xy' )        ! 2d-array
-                IF ( icloud_scheme == 1 )  THEN
-                   IF ( av == 0 )  THEN
-                      CALL exchange_horiz_2d( precipitation_rate )
-                      DO  i = nxlg, nxrg
-                         DO  j = nysg, nyng
-                            local_pf(i,j,nzb+1) =  precipitation_rate(j,i)
+                IF ( av == 0 )  THEN
+                   CALL exchange_horiz_2d( prr(nzb+1,:,:) )
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = prr(nzb+1,j,i) * hyrho(nzb+1)
+                      ENDDO
+                   ENDDO
+                ELSE
+                   CALL exchange_horiz_2d( prr_av(nzb+1,:,:) )
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = prr_av(nzb+1,j,i) * hyrho(nzb+1)
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+                two_d = .TRUE.
+                level_z(nzb+1) = zu(nzb+1)
+
+             CASE ( 'prr_xy', 'prr_xz', 'prr_yz' )
+                IF ( av == 0 )  THEN
+                   CALL exchange_horiz( prr, nbgp )
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         DO  k = nzb, nzt+1
+                            local_pf(i,j,k) = prr(k,j,i) * hyrho(nzb+1)
                          ENDDO
                       ENDDO
-                   ELSE
-                      CALL exchange_horiz_2d( precipitation_rate_av )
-                      DO  i = nxlg, nxrg
-                         DO  j = nysg, nyng
-                            local_pf(i,j,nzb+1) =  precipitation_rate_av(j,i)
-                         ENDDO
-                      ENDDO
-                   ENDIF
-                ELSE
-                   IF ( av == 0 )  THEN
-                      CALL exchange_horiz_2d( prr(nzb+1,:,:) )
-                      DO  i = nxlg, nxrg
-                         DO  j = nysg, nyng
-                            local_pf(i,j,nzb+1) = prr(nzb+1,j,i) * hyrho(nzb+1)
-                         ENDDO
-                      ENDDO
-                   ELSE
-                      CALL exchange_horiz_2d( prr_av(nzb+1,:,:) )
-                      DO  i = nxlg, nxrg
-                         DO  j = nysg, nyng
-                            local_pf(i,j,nzb+1) = prr_av(nzb+1,j,i) *          &
-                                                  hyrho(nzb+1)
-                         ENDDO
-                      ENDDO
-                   ENDIF
-                ENDIF
-                resorted = .TRUE.
-                two_d = .TRUE.
-                level_z(nzb+1) = zu(nzb+1)
-
-             CASE ( 'prr_xy', 'prr_xz', 'prr_yz' )
-                IF ( av == 0 )  THEN
-                   CALL exchange_horiz( prr, nbgp )
+                   ENDDO
+                ELSE
+                   CALL exchange_horiz( prr_av, nbgp )
                    DO  i = nxlg, nxrg
                       DO  j = nysg, nyng
                          DO  k = nzb, nzt+1
-                            local_pf(i,j,k) = prr(k,j,i)
-                         ENDDO
-                      ENDDO
-                   ENDDO
-                ELSE
-                   CALL exchange_horiz( prr_av, nbgp )
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         DO  k = nzb, nzt+1
-                            local_pf(i,j,k) = prr_av(k,j,i)
+                            local_pf(i,j,k) = prr_av(k,j,i) * hyrho(nzb+1)
                          ENDDO
                       ENDDO
